diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/seq.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/seq.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/seq.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/seq.c	Tue Jun 26 22:19:47 2007
@@ -89,7 +89,7 @@
 	      mode);
 
   if (!alib_appcheck ())
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   instance++;
 
@@ -104,12 +104,12 @@
     {
       fprintf (stderr, "salsa: snd_seq_open doesn't support streams=%d\n",
 	       streams);
-      return -EIO;
+      return RETERR(EIO);
     }
 #endif
 
   if ((seq = malloc (sizeof (*seq))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   dbg_printf ("Created sequencer seq=%x\n", seq);
 
@@ -132,7 +132,7 @@
 
     default:
       fprintf (stderr, "snd_seq_open: Unknown stream %x\n", streams);
-      return -ENODEV;
+      return RETERR(ENODEV);
     }
 
   if ((seq->fd = open (fname, oss_mode, 0)) == -1)
@@ -146,7 +146,7 @@
 		   "You can select another filename using environment variable %s_mididev%d\n",
 		   alib_appname, instance);
 	}
-      return -err;
+      return RETERR(err);
     }
 
   seq->streams = streams;
@@ -158,7 +158,7 @@
       if (seq->parser == NULL)
 	{
 	  fprintf (stderr, "libsalsa: Can't create MIDI parser\n");
-	  return -ENODEV;
+	  return RETERR(ENODEV);
 	}
     }
 
@@ -360,8 +360,8 @@
  *
  * If there is no input from sequencer, function falls into sleep
  * in blocking mode until an event is received,
- * or returns \c -EAGAIN error in non-blocking mode.
- * Occasionally, this function may return \c -ENOSPC error.
+ * or returns \c RETERR(EAGAIN) error in non-blocking mode.
+ * Occasionally, this function may return \c RETERR(ENOSPC) error.
  * This means that the input FIFO of sequencer overran, and some events are
  * lost.
  * Once this error is returned, the input FIFO is cleared automatically.
@@ -397,7 +397,7 @@
 
       // TODO Handling of nonblocking mode
       if ((l = read (seq->fd, buf, sizeof (buf))) == -1)
-	return -errno;
+	return RETERR(errno);
 
       midiparser_input_buf (seq->parser, buf, l);
 
@@ -489,7 +489,7 @@
 {
   dbg_printf ("snd_seq_query_next_port()\n");
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -526,7 +526,7 @@
 {
   dbg_printf ("snd_seq_subscribe_port()\n");
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -842,7 +842,7 @@
 {
   dbg_printf ("snd_seq_port_info_get_port()\n");
 
-  return -EIO;
+  return RETERR(EIO);
 }
 
 /**
@@ -907,7 +907,7 @@
 {
   dbg_printf ("snd_seq_query_next_client()\n");
 
-  return -EIO;
+  return RETERR(EIO);
 }
 
 /**
@@ -1241,7 +1241,7 @@
   dbg_printf ("snd_seq_port_info_malloc()\n");
 
   if ((p = malloc (sizeof (*p))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   *ptr = p;
 
@@ -1270,7 +1270,7 @@
   *ptr = calloc (1, sizeof (snd_seq_queue_tempo_t));
   dbg_printf ("snd_seq_queue_tempo_malloc()=%x\n", *ptr);
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1337,7 +1337,7 @@
 {
   dbg_printf ("snd_seq_get_queue_timer(seq=%x, q=%d, timer=%X)\n", seq, q,
 	      timer);
-  return -ENXIO;		// TODO
+  return RETERR(ENXIO);		// TODO
 }
 
 
@@ -1355,7 +1355,7 @@
 snd_timer_query_open (snd_timer_query_t ** timer, const char *name, int mode)
 {
   dbg_printf ("snd_timer_query_open(name=%s, mode=%x)\n", name, mode);
-  return -ENXIO;		// TODO
+  return RETERR(ENXIO);		// TODO
 }
 
 /**
@@ -1389,7 +1389,7 @@
 
   *ptr = malloc (sizeof (snd_seq_client_info_t));
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1457,7 +1457,7 @@
 
   *ptr = malloc (sizeof (snd_seq_system_info_t));
   if (*ptr == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1740,7 +1740,7 @@
   *ptr = calloc (1, sizeof (snd_seq_queue_status_t));
   dbg_printf ("snd_seq_queue_status_malloc()=%x\n", *ptr);
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1793,7 +1793,7 @@
   *ptr = calloc (1, sizeof (snd_seq_remove_events_t));
   dbg_printf ("snd_seq_remove_events_malloc()=%x\n", *ptr);
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1903,7 +1903,7 @@
 {
   dbg_printf ("snd_seq_extract_output(seq=%x)\n", seq);
 
-  return -EIO;
+  return RETERR(EIO);
 }
 
 /**
@@ -2051,7 +2051,7 @@
 
   dbg_printf ("snd_seq_query_subscribe_malloc()=%x\n", *ptr);
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/seq_output.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/seq_output.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/seq_output.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/seq_output.c	Tue Jun 26 22:19:47 2007
@@ -25,11 +25,11 @@
   int l;
 
   if (msg < 0 || msg >= 0xff)
-    return -ERANGE;
+    return RETERR(ERANGE);
   if (parm1 < 0 || parm1 > 0x7f)
-    return -ERANGE;
+    return RETERR(ERANGE);
   if (parm2 < 0 || parm2 > 0x7f)
-    return -ERANGE;
+    return RETERR(ERANGE);
 
   buf[0] = msg;
   buf[1] = parm1;
@@ -38,9 +38,9 @@
   if ((l = write (seq->fd, buf, 3)) != 3)
     {
       if (l == -1)
-	return -errno;
+	return RETERR(errno);
 
-      return -EBADE;		/* Randomly selected error */
+      return RETERR(EBADE);		/* Randomly selected error */
     }
 
   return 0;
@@ -53,9 +53,9 @@
   int l;
 
   if (msg < 0 || msg >= 0xff)
-    return -ERANGE;
+    return RETERR(ERANGE);
   if (parm1 < 0 || parm1 > 0x7f)
-    return -ERANGE;
+    return RETERR(ERANGE);
 
   buf[0] = msg;
   buf[1] = parm1;
@@ -63,9 +63,9 @@
   if ((l = write (seq->fd, buf, 2)) != 2)
     {
       if (l == -1)
-	return -errno;
+	return RETERR(errno);
 
-      return -EBADE;		/* Randomly selected error */
+      return RETERR(EBADE);		/* Randomly selected error */
     }
 
   return 0;
@@ -87,7 +87,7 @@
 		   ev->data.control.channel,
 		   ev->data.control.param, ev->data.control.value);
       if (ev->data.control.channel > 15)
-	return -ERANGE;
+	return RETERR(ERANGE);
       return midi_out3 (seq, 0xB0 + ev->data.control.channel,
 			ev->data.control.param, ev->data.control.value);
       break;
@@ -97,7 +97,7 @@
 		   ev->data.control.channel,
 		   ev->data.control.param, ev->data.control.value);
       if (ev->data.control.channel > 15)
-	return -ERANGE;
+	return RETERR(ERANGE);
       return midi_out2 (seq, 0xC0 + ev->data.control.channel,
 			ev->data.control.value);
       break;
@@ -107,7 +107,7 @@
 		   ev->data.control.channel, ev->data.control.value);
       value = ev->data.control.value + 8192;
       if (ev->data.control.channel > 15)
-	return -ERANGE;
+	return RETERR(ERANGE);
       return midi_out3 (seq, 0xD0 + ev->data.control.channel,
 			value & 0x7f, (value >> 7) & 0x7f);
       break;
@@ -117,7 +117,7 @@
 		   ev->data.control.channel, ev->data.control.value);
       value = ev->data.control.value + 8192;
       if (ev->data.control.channel > 15)
-	return -ERANGE;
+	return RETERR(ERANGE);
       return midi_out3 (seq, 0xE0 + ev->data.control.channel,
 			value & 0x7f, (value >> 7) & 0x7f);
       break;
@@ -127,7 +127,7 @@
 		   ev->data.note.channel,
 		   ev->data.note.note, ev->data.note.velocity);
       if (ev->data.control.channel > 15)
-	return -ERANGE;
+	return RETERR(ERANGE);
       return midi_out3 (seq, 0x90 + ev->data.note.channel,
 			ev->data.note.note, ev->data.note.velocity);
       break;
@@ -137,7 +137,7 @@
 		   ev->data.note.channel,
 		   ev->data.note.note, ev->data.note.velocity);
       if (ev->data.control.channel > 15)
-	return -ERANGE;
+	return RETERR(ERANGE);
       return midi_out3 (seq, 0x80 + ev->data.note.channel,
 			ev->data.note.note, ev->data.note.velocity);
       break;
@@ -147,7 +147,7 @@
 		   ev->data.note.channel,
 		   ev->data.note.note, ev->data.note.velocity);
       if (ev->data.control.channel > 15)
-	return -ERANGE;
+	return RETERR(ERANGE);
       return midi_out3 (seq, 0xA0 + ev->data.note.channel,
 			ev->data.note.note, ev->data.note.velocity);
       break;
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/timer.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/timer.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/timer.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/timer.c	Tue Jun 26 22:19:47 2007
@@ -52,7 +52,7 @@
   if (!alib_appcheck ())
     {
       dbg_printf ("snd_timer_open(%s, %x) refused,\n", name, mode);
-      return -ENODEV;
+      return RETERR(ENODEV);
     }
 
   timer = malloc (sizeof (*timer));
@@ -60,7 +60,7 @@
   dbg_printf ("snd_timer_open(name='%s', mode=%x)=%x\n", name, mode, timer);
 
   if (timer == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   *tmr = timer;
 
@@ -250,7 +250,7 @@
   *info = calloc (1, sizeof (snd_timer_info_t));
   dbg_printf ("snd_timer_info_malloc()=%x\n", *info);
   if (!*info)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -322,9 +322,9 @@
      name, timer_root, timer_conf, mode);
   ALIB_INIT ();
   if (!alib_appcheck ())
-    return -ENODEV;
+    return RETERR(ENODEV);
 
-  return -EIO;
+  return RETERR(EIO);
 }
 
 /**
diff -urN oss-v4.1test0-070624-src-gpl.org/misc/man9ossddk/ossddk_disable_device.9ossddk oss-v4.1test0-070624-src-gpl/misc/man9ossddk/ossddk_disable_device.9ossddk
--- oss-v4.1test0-070624-src-gpl.org/misc/man9ossddk/ossddk_disable_device.9ossddk	Wed Sep 14 12:01:05 2005
+++ oss-v4.1test0-070624-src-gpl/misc/man9ossddk/ossddk_disable_device.9ossddk	Tue Jun 26 22:19:47 2007
@@ -35,7 +35,7 @@
 OSS from accessing the driver any more.
 .PP
 .SH "RETURN VALUES"
-This function returns a negative value (-errno) if the device cannot be disabled at
+This function returns a negative value (RETERR(errno)) if the device cannot be disabled at
 this moment. In this case the driver should refuse to detach. Value of 0 means that
 the device was successfully disabled and the driver can proceed the detach operation.
 .PP
diff -urN oss-v4.1test0-070624-src-gpl.org/misc/man9ossddk/ossddk_install_audiodev.9ossddk oss-v4.1test0-070624-src-gpl/misc/man9ossddk/ossddk_install_audiodev.9ossddk
--- oss-v4.1test0-070624-src-gpl.org/misc/man9ossddk/ossddk_install_audiodev.9ossddk	Mon Feb 12 01:32:48 2007
+++ oss-v4.1test0-070624-src-gpl/misc/man9ossddk/ossddk_install_audiodev.9ossddk	Tue Jun 26 22:19:47 2007
@@ -233,7 +233,7 @@
 .PP
 .SH "RETURN VALUES"
 .PP
-Negative value is an error code (-errno). Zero or positive is the audio device
+Negative value is an error code (RETERR(errno)). Zero or positive is the audio device
 number created.
 .PP
 .SH "SEE ALSO"
diff -urN oss-v4.1test0-070624-src-gpl.org/misc/man9ossddk/ossddk_install_mixer.9ossddk oss-v4.1test0-070624-src-gpl/misc/man9ossddk/ossddk_install_mixer.9ossddk
--- oss-v4.1test0-070624-src-gpl.org/misc/man9ossddk/ossddk_install_mixer.9ossddk	Tue Sep 13 13:16:56 2005
+++ oss-v4.1test0-070624-src-gpl/misc/man9ossddk/ossddk_install_mixer.9ossddk	Tue Jun 26 22:19:48 2007
@@ -86,7 +86,7 @@
 .PP
 .SH "RETURN VALUES"
 .PP
-Negative value is an error code (-errno). Zero or positive is the mixer device
+Negative value is an error code (RETERR(errno)). Zero or positive is the mixer device
 number created.
 .PP
 .SH "SEE ALSO"
diff -urN oss-v4.1test0-070624-src-gpl.org/misc/samples/ddksample/ddksample_audio.c oss-v4.1test0-070624-src-gpl/misc/samples/ddksample/ddksample_audio.c
--- oss-v4.1test0-070624-src-gpl.org/misc/samples/ddksample/ddksample_audio.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/misc/samples/ddksample/ddksample_audio.c	Tue Jun 26 22:19:48 2007
@@ -171,7 +171,7 @@
 ddksample_ioctl (int dev, unsigned int cmd, int *arg)
 {
 // TODO 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void ddksample_trigger (int dev, int state);
@@ -193,7 +193,7 @@
   if (portc->open_mode != 0)	/* Device busy */
     {
       mutex_exit (&devc->mutex);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -348,7 +348,7 @@
   ossddk_dmap_set_phys (dmap, 0);	/* Not mmap() capable */
   ossddk_dmap_set_dmabuf (dmap, kmem_zalloc (MY_BUFFSIZE, KM_SLEEP));
   if (ossddk_dmap_get_dmabuf (dmap) == NULL)	/* Alloc failed */
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   ossddk_dmap_set_buffsize (dmap, MY_BUFFSIZE);
 
   return 0;
diff -urN oss-v4.1test0-070624-src-gpl.org/misc/samples/ddksample/ddksample_mixer.c oss-v4.1test0-070624-src-gpl/misc/samples/ddksample/ddksample_mixer.c
--- oss-v4.1test0-070624-src-gpl.org/misc/samples/ddksample/ddksample_mixer.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/misc/samples/ddksample/ddksample_mixer.c	Tue Jun 26 22:19:48 2007
@@ -80,7 +80,7 @@
   ddksample_devc *devc = ossddk_mixer_get_devc (dev);
 
   if (ctl_id < 0 || ctl_id >= devc->num_portc)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -112,7 +112,7 @@
     }
 
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -121,7 +121,7 @@
   ddksample_devc *devc = ossddk_mixer_get_devc (dev);
 
   if (ctl_id < 0 || ctl_id >= devc->num_portc)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_WRITE)
     {
@@ -137,7 +137,7 @@
       return portc->mute;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -146,7 +146,7 @@
   ddksample_devc *devc = ossddk_mixer_get_devc (dev);
 
   if (ctl_id < 0 || ctl_id >= devc->num_portc)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_WRITE)
     {
@@ -177,7 +177,7 @@
       return portc->left_volume | (portc->right_volume << 8);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -324,7 +324,7 @@
       break;
 
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
diff -urN oss-v4.1test0-070624-src-gpl.org/oss/lib/flashsupport.c oss-v4.1test0-070624-src-gpl/oss/lib/flashsupport.c
--- oss-v4.1test0-070624-src-gpl.org/oss/lib/flashsupport.c	Tue Jun 12 14:22:35 2007
+++ oss-v4.1test0-070624-src-gpl/oss/lib/flashsupport.c	Tue Jun 26 22:19:48 2007
@@ -513,12 +513,12 @@
 		{
 		  switch (result)
 		    {
-		    case -EPIPE:
+		    case RETERR(EPIPE):
 		      {
 			snd_pcm_prepare (instance->handle);
 		      }
 		      break;
-		    case -ESTRPIPE:
+		    case RETERR(ESTRPIPE):
 		      {
 			err = snd_pcm_resume (instance->handle);
 			if (err < 0)
@@ -543,12 +543,12 @@
 	    {
 	      switch (avail)
 		{
-		case -EPIPE:
+		case RETERR(EPIPE):
 		  {
 		    snd_pcm_prepare (instance->handle);
 		  }
 		  break;
-		case -ESTRPIPE:
+		case RETERR(ESTRPIPE):
 		  {
 		    err = snd_pcm_resume (instance->handle);
 		    if (err < 0)
diff -urN oss-v4.1test0-070624-src-gpl.org/setup/BeOS/build.sh oss-v4.1test0-070624-src-gpl/setup/BeOS/build.sh
--- oss-v4.1test0-070624-src-gpl.org/setup/BeOS/build.sh	Thu Jan  1 01:00:00 1970
+++ oss-v4.1test0-070624-src-gpl/setup/BeOS/build.sh	Tue Jun 26 23:52:42 2007
@@ -0,0 +1,149 @@
+#!/bin/sh
+
+. ./.directories
+
+BEOS_SYSTEM=beos/system
+# to install as user addons
+#BEOS_SYSTEM=home/config
+
+DRVPREFIX=oss_
+
+rm -rf prototype
+
+mkdir prototype
+#mkdir prototype/etc
+#echo OSSLIBDIR=/usr/lib/oss > prototype/etc/oss.conf
+
+TXT2MAN=$SRCDIR/setup/txt2man
+
+if test ! -f /usr/local/bin/gawk
+then
+  # No gawk installed. Use the simple txt2man program instead of
+  # the fully featured shell script which depends on gawk.
+
+  rm -f txt2man
+  
+  cc -o txt2man $SRCDIR/setup/txt2man.c
+  
+  if test -f txt2man
+  then
+    TXT2MAN=./txt2man
+  fi
+fi
+
+mkdir -p prototype/$BEOS_SYSTEM/add-ons/kernel/drivers/bin
+mkdir -p prototype/$BEOS_SYSTEM/add-ons/kernel/drivers/dev/audio/multi
+mkdir -p prototype/home/config/settings/kernel/drivers
+
+#cp $SRCDIR/include/soundcard.h prototype/usr/include/sys
+
+#cp .version prototype/usr/lib/oss/version.dat
+
+#cp -R $SRCDIR/include/* prototype/usr/lib/oss/include/sys/
+#cp $SRCDIR/kernel/framework/include/midiparser.h prototype/usr/lib/oss/include/
+
+#cp -f target/bin/* prototype/usr/bin
+#cp -f target/sbin/* prototype/usr/sbin
+#cp -f $SRCDIR/setup/SCO_SV/sbin/* prototype/usr/sbin
+
+#cp -R $SRCDIR/oss prototype/usr/lib
+#cp -R $SRCDIR/setup/SCO_SV/oss prototype/usr/lib
+
+#ld -r -o prototype/usr/lib/oss/modules/osscore/Driver.o target/objects/*.o $SRCDIR/setup/SCO_SV/*.o $FPSUPPORT
+drv=prototype/$BEOS_SYSTEM/add-ons/kernel/drivers/bin/${DRVPREFIX}core
+#gcc -o $drv target/objects/*.o -nostdlib /boot/develop/lib/x86/_KERNEL_ || exit 1
+
+# try to build all in a single bin for now...
+gcc -o $drv target/objects/*.o target/modules/*.o -nostdlib /boot/develop/lib/x86/_KERNEL_ || exit 1
+exit 0
+##########
+
+#grep '^int' $SRCDIR/kernel/framework/osscore/options.c > prototype/usr/lib/oss/modules/osscore/Space.c
+
+rm -f devlist.txt
+
+for n in target/modules/*.o
+do
+	N=`basename $n .o`
+	#mkdir prototype/usr/lib/oss/modules/$N
+	#cp target/build/$N/* prototype/usr/lib/oss/modules/$N
+	#ld -r -o prototype/usr/lib/oss/modules/$N/Driver.o $n
+	drv=prototype/$BEOS_SYSTEM/add-ons/kernel/drivers/bin/${DRVPREFIX}$N
+	gcc -o $drv $n -nostdlib /boot/develop/lib/x86/_KERNEL_ || exit 1
+	longver="`cat .version`"
+	shortver="${longver%% *}"
+	appver="${shortver:0:1} ${shortver:0:1} 0 b ${shortver##*[a-z]}"
+	lic="`cat .license`"
+	copyright="`echo -n -e '\302\251'` 2007 4Front"
+	setversion $drv -app $appver -short $shortver -long "$longver $copyright $lic"
+	mimeset -f $drv
+
+# Now copy the man pages
+#	if test -f $SRCDIR/kernel/drv/$N/$N.man
+#        then
+#	     sed 's/CONFIGFILEPATH/\/usr\/lib\/oss\/conf/' < $SRCDIR/kernel/drv/$N/$N.man > /tmp/ossman.tmp
+#             $TXT2MAN -t "$N" -v "Devices" -s 7d /tmp/ossman.tmp > prototype/usr/man/man7/$N.7
+#	fi
+
+#        if test -f $SRCDIR/kernel/nonfree/drv/$N/$N.man
+#	then
+#	     sed 's/CONFIGFILEPATH/\/usr\/lib\/oss\/conf/' < $SRCDIR/kernel/nonfree/drv/$N/$N.man > /tmp/ossman.tmp
+#	     $TXT2MAN -t "$N" -v "Devices" -s 7d /tmp/ossman.tmp > prototype/usr/man/man7/$N.7
+#	fi
+
+echo Check devices for $N
+  	grep "^$N[ 	]" ./devices.list >> devlist.txt
+done
+
+#cp devlist.txt prototype/usr/lib/oss/etc/devices.list
+
+#sed 's/.*	//' <  devlist.txt|sort|uniq >$SRCDIR/devlists/OSR6
+cp devlist.txt $SRCDIR/devlists/BeOS
+
+# Generate Man pages for commands
+#for i in target/bin/*
+#do
+#CMD=`basename $i`
+#$TXT2MAN -t "$CMD" -v "User Commands" -s 1 cmd/$CMD/$CMD.man > prototype/usr/man/man1/$CMD.1
+#echo done $CMD
+#done
+
+#for i in target/sbin/*
+#do
+#  CMD=`basename $i`
+#  if test -f cmd/$CMD/$CMD.man
+#  then
+#	$TXT2MAN -t "$CMD" -v "System Administration Commands" -s 8 cmd/$CMD/$CMD.man > prototype/usr/man/man8/$CMD.8
+#	echo done $CMD
+#  fi
+#done
+
+#rm -f prototype/usr/man/man8/ossdetect.8
+#$TXT2MAN -t "ossdetect" -v "User Commands" -s 8 os_cmd/SCO_SV/ossdetect/ossdetect.man > prototype/usr/man/man8/ossdetect.8
+#echo done ossdetect
+
+## Licensing stuff
+#if test -f $SRCDIR/4front-private/osslic.c
+#then
+#	cc -o prototype/usr/sbin/osslic -Isetup -Ikernel/nonfree/include -Ikernel/framework/include -Iinclude -Ikernel/OS/SCO_SV -I$SRCDIR $SRCDIR/4front-private/osslic.c
+#	strip prototype/usr/sbin/osslic
+#	
+#	prototype/usr/sbin/osslic -q -u -3prototype/usr/lib/oss/modules/osscore/Driver.o
+#	
+#fi
+
+#if test -f 4front-private/ossupdate.c
+#then
+#  # ossupdate
+#  cc -I. 4front-private/ossupdate.c -s -o prototype/usr/sbin/ossupdate -lsocket -lbind
+#fi
+
+#chmod 700 prototype/usr/sbin/*
+#chmod 755 prototype/usr/bin/*
+
+#cp setup/SCO_SV/S89oss prototype/usr/lib/oss/etc
+#chmod 744 prototype/usr/lib/oss/etc/S89oss
+
+#exec sh $SRCDIR/setup/build_common.sh $SRCDIR
+
+exit 0
diff -urN oss-v4.1test0-070624-src-gpl.org/setup/BeOS/make.local oss-v4.1test0-070624-src-gpl/setup/BeOS/make.local
--- oss-v4.1test0-070624-src-gpl.org/setup/BeOS/make.local	Thu Jan  1 01:00:00 1970
+++ oss-v4.1test0-070624-src-gpl/setup/BeOS/make.local	Tue Jun 26 22:19:48 2007
@@ -0,0 +1,19 @@
+build: 	kernel/framework/include/buildid.h all
+	sh build.sh
+
+copy:	build
+	cp -R prototype/* /
+
+package:	build
+		cd setup/BeOS && sh mkpkg.sh
+
+tarball:	build
+		sh setup/BeOS/mktarball.sh
+
+deb:		package
+		alien --to-deb --scripts --keep-version oss-linux*.rpm
+
+install:	copy
+	cd /usr/lib/oss/build && sh install.sh
+	sync
+	soundoff && sync && soundon
diff -urN oss-v4.1test0-070624-src-gpl.org/setup/setupdir.sh~ oss-v4.1test0-070624-src-gpl/setup/setupdir.sh~
--- oss-v4.1test0-070624-src-gpl.org/setup/setupdir.sh~	Thu Jan  1 01:00:00 1970
+++ oss-v4.1test0-070624-src-gpl/setup/setupdir.sh~	Sun Jun 24 18:05:22 2007
@@ -0,0 +1,169 @@
+#!/bin/sh -e
+
+if test "$CONFIGURE " != "YES "
+then
+	echo
+	echo Error: Wrong usage
+	echo
+	echo You must run `dirname $0`/configure instead of $0
+	exit 1
+fi
+
+echo srcdir=$SRCDIR
+
+BLDDIR=`pwd`
+OS=`uname -s`
+
+# Use the same source directories for SCO UnixWare and SCO OSR
+if test "$OS " = "UnixWare "
+then
+	OS=SCO_SV
+fi
+
+# pkg-config seems to crash in some systems so disable core dumps
+ulimit -c 0>/dev/null 2>&1
+
+if pkg-config gtk+-2.0 --cflags > /dev/null 2>&1
+then
+  HAVE_GTK=y
+  export HAVE_GTK
+fi
+
+if gtk-config --cflags > /dev/null 2>&1
+then
+  HAVE_GTK=y
+  export HAVE_GTK
+fi
+
+if test "`ls .` " != " " && test "`ls .` " != ".makefile "
+then
+	echo Error: Current directory must be empty
+	exit 1
+fi
+
+if test -f $SRCDIR/setup/setupdir.sh
+then
+	echo Source directory is $SRCDIR
+	echo Build directory is $BLDDIR
+else
+	echo Error: Invalid source directory $SRCDIR
+	exit 2
+fi
+
+# Copy the ".devices" files for all drivers to devices.list
+cat `find $SRCDIR/kernel -name .devices`|grep -v '^#' > devices.list
+
+echo BLDDIR=$BLDDIR > .directories
+echo SRCDIR=$SRCDIR >> .directories
+
+cc -o dirsetup $SRCDIR/setup/dirsetup.c
+
+# Make sure the latest soundcard.h version is installed in the system
+#rm /usr/include/sys/soundcard.h
+#cp $SRCDIR/include/soundcard.h /usr/include/sys/soundcard.h
+
+if ./dirsetup "$SRCDIR" "$BLDDIR" $*
+then
+	echo Build tree created OK
+else
+	echo Cannot create the build tree
+	rm -f dirsetup
+	exit 3
+fi
+
+rm -f dirsetup
+
+cc -D`uname -s` -o srcconf $SRCDIR/setup/srcconf.c
+
+if ./srcconf $*
+then
+	echo Source configuration OK
+else
+	echo Source configuration failed
+fi
+
+if test ! -d target
+then
+	mkdir target
+fi
+
+mkdir target/bin
+mkdir target/sbin
+mkdir target/modules
+mkdir target/objects
+mkdir target/tmpobjects
+
+touch .depend
+
+if date -u +%Y%m%d%H%M > build.id.new 2>/dev/null
+then
+	rm -f build.id
+	mv build.id.new build.id
+	echo "#define OSS_COMPILE_DATE \""`cat build.id`"\"" >> kernel/framework/include/timestamp.h
+	echo "#define osdev_create osdev_create_`cat build.id`" >> kernel/framework/include/timestamp.h
+	echo
+	echo Build ID will become `cat build.id`
+else
+	echo Failed to create the build timestamp
+	exit 254
+fi
+
+if test -f $SRCDIR/.date
+then
+	# Use source package release date as the build ID
+
+	rm -f buildid.dat
+	cat $SRCDIR/.date > buildid.dat
+else
+	echo "#define LICENSED_VERSION" >> kernel/framework/include/timestamp.h
+fi
+
+if test -f $SRCDIR/buildid.dat
+then
+	echo '#define 'OSS_BUILD_ID \"`cat $SRCDIR/buildid.dat`\" > kernel/framework/include/buildid.h
+else
+	echo $SRCDIR/buildid.dat is missing
+	exit 10
+fi
+
+if test ! -d kernel/nonfree || test -f $SRCDIR/kernel/nonfree/.nomake
+then
+	echo '#define __OPENOSS__' >> kernel/framework/include/buildid.h
+	echo '#define OSS_LICENSE "/'`cat $SRCDIR/.license`'"' >> kernel/framework/include/buildid.h
+fi
+
+if test "$USE_REGPARM " = "1 "
+then
+	echo "1" > ./regparm
+fi
+
+if test "$NO_REGPARM " = "1 "
+then
+	echo "0" > ./regparm
+fi
+
+# Setup the link to the right os.h file for this operating system.
+(cd kernel/framework/include;ln -s ../../../kernel/OS/$OS/os_*.h os.h)
+
+cc -o ossvers -I./kernel/framework/include  setup/ossvers.c
+./ossvers > .version
+rm ./ossvers
+
+make dep
+
+ln -s $SRCDIR origdir
+if test -f setup/$OS/build.sh
+then
+	ln -s setup/$OS/build.sh .
+fi
+
+if test -f setup/$OS/make.local
+then
+	echo >> Makefile
+	echo include setup/$OS/make.local >> Makefile
+fi
+
+echo Directory preparation complete.
+echo Build ID will be `cat $SRCDIR/buildid.dat`
+
+exit 0
diff -urN oss-v4.1test0-070624-src-gpl.org/setup/srcconf.c oss-v4.1test0-070624-src-gpl/setup/srcconf.c
--- oss-v4.1test0-070624-src-gpl.org/setup/srcconf.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/setup/srcconf.c	Tue Jun 26 22:19:49 2007
@@ -329,6 +329,10 @@
 #include "gen_driver_sco.inc"
 #endif
 
+#if defined(__BEOS__)
+#include "gen_driver_beos.inc"
+#endif
+
 static int
 is_cplusplus (char *fname)
 {
@@ -671,6 +675,10 @@
 # endif
 #endif
 
+#if defined(__BEOS__)
+      fprintf (f, "CFLAGS=-O2 -D_KERNEL -D_KERNEL_MODE=1 -no-fpic\n");
+#endif
+
     }
 
   if (conf.mode != MD_KERNEL)
@@ -913,6 +921,10 @@
 
 #ifdef sun
 #include "srcconf_solaris.inc"
+#endif
+
+#ifdef __BEOS__
+#include "srcconf_beos.inc"
 #endif
 
 static void
diff -urN oss-v4.1test0-070624-src-gpl.org/setup/srcconf_beos.inc oss-v4.1test0-070624-src-gpl/setup/srcconf_beos.inc
--- oss-v4.1test0-070624-src-gpl.org/setup/srcconf_beos.inc	Thu Jan  1 01:00:00 1970
+++ oss-v4.1test0-070624-src-gpl/setup/srcconf_beos.inc	Tue Jun 26 22:19:49 2007
@@ -0,0 +1,39 @@
+#define HAVE_SYSDEP
+static void
+check_sysdep (conf_t * conf)
+{
+  struct utsname un;
+
+  if (uname (&un) == -1)
+    {
+      perror ("uname");
+      exit (-1);
+    }
+
+  if (strcmp (un.sysname, "Haiku") == 0)
+    strcpy (un.sysname, "BeOS");
+
+  strcpy (conf->cplusplus, "g++ -fno-rtti -fno-exceptions -I.");
+
+  /* fixup machine names */
+  if (strcmp (un.machine, "BePC") == 0)
+    {
+      strcpy (conf->arch, "i586");
+    }
+  if (strcmp (un.machine, "BePC") == 0 ||
+      strcmp (un.machine, "i386") == 0 ||
+      strcmp (un.machine, "i486") == 0 ||
+      strcmp (un.machine, "i586") == 0 || strcmp (un.machine, "i686") == 0)
+    {
+      strcpy (conf->platform, "i86pc");
+    }
+  if (strcmp (un.machine, "BeMac") == 0 ||
+      strcmp (un.machine, "BeBox") == 0)
+    {
+      /* XXX: those are PPC 
+      strcpy (conf->arch, "ppc");
+      strcpy (conf->platform, "ppc");*/
+      fprintf(stderr, "FIXME: convert arch/machine BeMac/BeBox\n");
+      exit(1);
+    }
+}
diff -urN oss-v4.1test0-070624-src-gpl.org/utils/snoopy.c oss-v4.1test0-070624-src-gpl/utils/snoopy.c
--- oss-v4.1test0-070624-src-gpl.org/utils/snoopy.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/utils/snoopy.c	Tue Jun 26 22:19:49 2007
@@ -880,7 +880,7 @@
  */
 
   if (!corb_read (mixer, cad, 0, 0, GET_PARAMETER, HDA_NODE_COUNT, &a, &b))
-    return -EIO;
+    return RETERR(EIO);
 
   first_node = (a >> 16) & 0xff;
   num_nodes = a & 0xff;
